{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
{$ifdef FPC} {$mode delphi} {$endif}
unit Unit1; 

interface

uses Windows, Messages, KOL {place your units here->}
{$IFDEF LAZIDE_MCK}, Forms, mirror, Classes, Controls, mckCtrls, mckObjs, Graphics;
{$ELSE} ; {$ENDIF}

type

  { TForm1 }

  {$I MCKfakeClasses.inc}
  {$IFDEF KOLCLASSES} TForm1 = class; PForm1 = TForm1; {$ELSE OBJECTS} PForm1 = ^TForm1; {$ENDIF CLASSES/OBJECTS}
  TForm1 = {$IFDEF KOLCLASSES}class{$ELSE}object{$ENDIF}({$IFDEF LAZIDE_MCK}TForm{$ELSE}TObj{$ENDIF})
    Button1: TKOLButton;
    Button2: TKOLButton;
    Form: PControl;
    KOLForm1: TKOLForm;
    KOLProject1: TKOLProject;
    Label1: TKOLLabel;
    Label2: TKOLLabel;
    Panel1: TKOLPanel;
    Panel2: TKOLPanel;
    ScrollBox1: TKOLScrollBox;
    procedure Button1Click(Sender: PObj);
    procedure Button2Click(Sender: PObj);
    procedure KOLForm1FormCreate(Sender: PObj);

    procedure ScrollBox1Resize(Sender: PObj);
  private
    { private declarations }
     seqcount : integer;
  public
    { public declarations }
  end; 

var
  Form1 {$IFDEF KOL_MCK} : PForm1 {$ELSE} : TForm1 {$ENDIF} ;

{$IFDEF KOL_MCK}
procedure NewForm1( var Result: PForm1; AParent: PControl );
{$ENDIF}

implementation

{$IFDEF KOL_MCK}
{$I unit1_1.inc}
{$ENDIF}

{ TForm1 }

procedure TForm1.Button1Click(Sender: PObj);
var
   n           : integer;
   totalheight : integer;
   alabel      : TKolLabel;
   ATickcount  : int64;
   AEditbox    : TKolEditBox;
   ADateTimePicker : TKolDateTimePicker;
   APaintbox       : TKolPaintbox;
   
begin
  inc(seqcount);
  // remove existing objects:
  if panel2.ChildCount>0
   then
    begin
     for n:=panel2.ChildCount-1 downto 0 do
      panel2.Children[n].free;
    end;

  ATickCount:=GetTickcount;
  Label2.Caption:='-';
  Label2.Update;
  
  // build the form on panel2
  
  // first resize panel2 that it fits nicely in the scrollbox:
  panel2.Height := Scrollbox1.ClientHeight+10; // force vertical scrollbar
  panel2.Width  := Scrollbox1.Clientwidth -3;     // no horizontal scrollbar
  totalheight   := 0;

  for n:=1 to 50 do
   begin
    ALabel          := NewWordwraplabel(panel2,#13+'seq '+int2str(seqcount)+' - '+int2str(n)+': Long text that certainly does not fit on line and have to wordwrap:');
    alabel^.Align   := caTop;
    // force correc wordwrap, otherwise it won't
    ALabel^.AutoSize(True);
    totalheight     := totalheight+ALabel^.Height;

    // show editbox, paintbox, datetimepicker
    if n mod 3 = 1
     then
      begin
       AEditBox          := NewEditbox(panel2,[]);
       aEditbox^.Align   := caTop;
       aEditbox^.Tag     := n;
       aEditbox^.Font.FontStyle := [fsBold];
       aEditbox^.Text    :='Test';
       totalheight       := totalheight+aEditbox^.Height;
      end;
      
    if n mod 3 = 2
     then
      begin
       ADateTimePicker          := NewDateTimePicker(panel2,[]);
       ADateTimePicker^.Align   := caTop;
       ADateTimePicker^.Tag     := n;
       ADateTimePicker^.Font.Fontstyle := [fsBold];
       totalheight              := totalheight+ADateTimePicker^.Height;
      end;

    if n mod 3 = 0
     then
      begin
       APaintbox          := NewPaintbox(panel2);
       APaintbox^.Align   := caTop;
       APaintbox^.Tag     := n;
       totalheight        := totalheight+APaintbox^.Height;
      end;

   end;


 Panel2.Height:=TotalHeight;
 
 // The objects won't show, panel2 stays visually empty, dunno why, but this helps:
 scrollbox1.Invalidate ;
 
 
 // show elapsed time:
 label2.Caption:=int2str(gettickcount-ATickcount)+' ms';
 // ^^
 // this label is shown "long" before the update of the screen is actually finished
 // so the update of the screen is still going on at the end of this procedure?
 // this is clearly visible when repeatedly pressing 'TST'
 // en watching the elapsed time appear and after that, watching the seqcount
 // appear in the text on Panel2

end;

procedure TForm1.Button2Click(Sender: PObj);
begin
  Form.Close;
end;

procedure TForm1.KOLForm1FormCreate(Sender: PObj);
begin
  // initialize tst sequencecounter:
  seqcount:=0;
  
  {$IFNDEF WINCE}
  // show at size of pocket-pc if run on Win32
  Form.top   := 100;
  Form.width := 240;
  Form.height:= 320;
  Form.left  := 100;
  {$ENDIF}
end;


procedure TForm1.ScrollBox1Resize(Sender: PObj);
begin
  // make sure the panel fits the scrollbox-area after switching
  // from portrait to landscape or viceversa

  Panel2.Width:=scrollbox1.Clientwidth-3;


end;

initialization
{$IFNDEF KOL_MCK} {$I unit1.lrs} {$ENDIF}

end.

